.386
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib

WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
DlgProc PROTO :HWND, :DWORD, :DWORD, :DWORD

.data
IDM_EXIT equ 1
IDM_ABOUT equ 2
IDC_EXIT equ 3002

ClassName db "PetezlWinClass",0
AppName db "Dialog as Main Window",0
MenuName db "FirstMenu",0
;DlgName db "MyDialog",0            ;not needed because we are using an ID number
TestString db "Hello, everybody",0
hwndDlg dd 0 ; Handle to the extra dialog

.data?
hInstance HINSTANCE ?
CommandLine LPSTR ?
; 

.code
start:
invoke GetModuleHandle, NULL
mov hInstance,eax
invoke GetCommandLine
invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
invoke ExitProcess,eax
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG
LOCAL hwnd:HWND
mov wc.cbSize,SIZEOF WNDCLASSEX
mov wc.style, CS_HREDRAW or CS_VREDRAW
mov wc.lpfnWndProc, OFFSET WndProc
mov wc.cbClsExtra,NULL
mov wc.cbWndExtra,NULL
push hInst
pop wc.hInstance
mov wc.hbrBackground,COLOR_WINDOW+1
mov wc.lpszMenuName,OFFSET MenuName
mov wc.lpszClassName,OFFSET ClassName
invoke LoadIcon,NULL,IDI_APPLICATION
mov wc.hIcon,eax
mov wc.hIconSm,eax
invoke LoadCursor,NULL,IDC_ARROW
mov wc.hCursor,eax
invoke RegisterClassEx, addr wc
INVOKE CreateWindowEx,WS_EX_CLIENTEDGE,ADDR ClassName,ADDR AppName,\
WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
CW_USEDEFAULT,300,200,NULL,NULL,\
hInst,NULL
mov hwnd,eax
INVOKE ShowWindow, hwnd,SW_SHOWNORMAL
INVOKE UpdateWindow, hwnd
.WHILE TRUE
INVOKE GetMessage, ADDR msg,NULL,0,0
.BREAK .IF (!eax)
.if hwndDlg!=0
invoke IsDialogMessage,hwndDlg,ADDR msg
.if eax==TRUE
.continue
.endif
.endif
INVOKE TranslateMessage, ADDR msg
INVOKE DispatchMessage, ADDR msg
.ENDW
mov eax,msg.wParam
ret
WinMain endp
; 

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

;This is the message loop for the main application 

.IF uMsg==WM_DESTROY
      invoke PostQuitMessage,NULL

.ELSEIF uMsg==WM_COMMAND
      mov eax,wParam

      .if ax==IDM_ABOUT
            invoke CreateDialogParam,hInstance, 700,hWnd,OFFSET DlgProc,NULL ;// 700 used instead of DlgName
            mov hwndDlg,eax
      .else
            invoke DestroyWindow, hWnd
      .endif
.ELSE
      invoke DefWindowProc,hWnd,uMsg,wParam,lParam
      ret
.ENDIF
xor eax,eax
ret
WndProc endp
; 

DlgProc PROC hWnd:HWND,iMsg:DWORD,wParam:WPARAM, lParam:LPARAM

; this is the procedure for the extra dialog

.if iMsg==WM_INITDIALOG

.elseif iMsg==WM_CLOSE
      invoke EndDialog,hWnd,NULL
      mov hwndDlg,0

.elseif iMsg==WM_COMMAND
      mov eax,wParam
      mov edx,eax
      shr edx,16
      
      .if dx==BN_CLICKED
            .if eax==IDC_EXIT
                  invoke SendMessage,hWnd,WM_CLOSE,NULL,NULL
                  
            .endif
      .endif
       
.else
mov eax,FALSE
ret
.endif
mov eax,TRUE
ret
DlgProc endp
; 

end start
